--[[------------------------------------------------
	-- GUI --
--]]------------------------------------------------

GUI = {}
GUI.Title = {}
local font = love.graphics.newFont(10)
local ScrW = love.graphics.getWidth()
local ScrH = love.graphics.getHeight()


local panel = loveframes.Create("panel")
panel:SetSize(150, 200)

colcat = loveframes.Create("collapsiblecategory")

colcat:SetWidth(130)
colcat:SetPos(5,5)
colcat:SetText("Console")
colcat:SetObject(panel)
colcat:SetOpen(true)


local textX = loveframes.Create("text", panel)

textX:SetPos(5, 5)
textX:SetMaxWidth(100)
textX:SetFont(font)
textX:SetText("Default")


local textobs = loveframes.Create("text", panel)
textobs:SetPos(5, 20)
textobs:SetMaxWidth(100)
textobs:SetFont(font)
textobs:SetText("Default")


local textobj = loveframes.Create("text", panel)
textobj:SetPos(5, 35)
textobj:SetMaxWidth(100)
textobj:SetFont(font)
textobj:SetText("Default")

local textuse = loveframes.Create("text", panel)
textuse:SetPos(5, 50)
textuse:SetMaxWidth(100)
textuse:SetFont(font)
textuse:SetText("Default")


local textboxtext = loveframes.Create("text", panel)
textboxtext:SetPos(5, 200-80)
textboxtext:SetMaxWidth(100)
textboxtext:SetFont(font)
textboxtext:SetText("")

local textinput = loveframes.Create("textinput", panel)
textinput:SetPos(5, 200-30)
textinput:SetWidth(110)
textinput.OnEnter = function(object, text)
	

	
end




function GUI.Console(tbl)


textX:SetText("Pos: "..tostring(tbl.x)..","..tostring(tbl.y).." : "..tostring(tbl.xx)..","..tostring(tbl.yy))
textboxtext:SetText("Pos: "..tostring(tbl.gx).."  ,  "..tostring(tbl.gy))
textobs:SetText("Obstacle: "..tostring(tbl.obstacle))
textobj:SetText("Useable: "..tostring(tbl.useable))
textuse:SetText(tostring(tbl.checkName).." : "..tostring(tbl.checkBool))



end

function GUI.ShowTable(tbl)
local frame = loveframes.Create("frame")
frame:SetSize(500, 300)
frame:SetPos(5,5)

local columnlist = loveframes.Create("columnlist", frame)
columnlist:SetPos(5, 30)
columnlist:SetSize(490, 265)
columnlist:AddColumn("Index")
columnlist:AddColumn("Item")


for k, v in pairs(tbl) do

	columnlist:AddRow(tostring(k), tostring(v))
	
end


end

--[[ function GUI.Title.Menu(tbl)

	
local frame = loveframes.Create("frame")
frame:SetSize(500, 300)
frame:SetPos(5,5)

local columnlist = loveframes.Create("columnlist", frame)
columnlist:SetPos(5, 30)
columnlist:SetSize(490, 265)
columnlist:AddColumn("X")
columnlist:AddColumn("Y")
columnlist:AddColumn("Tile Table")

--love.graphics.print(tbl)
newTable = {}
 for k, v in pairs(tbl) do
	for i, j in pairs(v) do
		--love.graphics.print(j)
		for n, m in pairs(j) do
      columnlist:AddRow(tostring(k),i,tostring(m))
   end
end

end
for i=1, 16 do

--	columnlist:AddRow(tostring(tbl[i]), tostring(tbl[i][i]), tostring(tbl[i][i][i]))
end

end ]]


