
-- Setup
ConsoleInfo = {} --A table that is used for console


local loader = require("libraries/AdvTiledLoader.Loader")
loader.path = "maps/"
local map = loader.load("inn.tmx")
local layer = map.tl["Ground"]
local furni = map.tl["Furniture"]
require("gui")
require("libraries/TEsound")
local anim8 = require("libraries/anim8")

local music = {"sounds/error.mp3", "sounds/dogquake.mp3", "sounds/dustcup.mp3", "sounds/hobotune.mp3"}





	
-- This is the guy we'll be moving around.
local Guy = map.ol["Object1"]:newObject("Guy", "Entity",0,0,32,64)
Guy.tileX = 5		-- The horizontal tile
Guy.tileY = 13		-- The vertical tile
Guy.facing = "down"	-- The direction our guy is facing
Guy.speed = 4
Guy.moveTilePlusX = 0
Guy.moveTilePlusY = 0
Guy.quads = {		-- The frames of the image
		down = 		love.graphics.newQuad(0,0,32,64,256,64),
		downright = love.graphics.newQuad(32,0,32,64,256,64),
		right = 	love.graphics.newQuad(64,0,32,64,256,64),
		upright = 	love.graphics.newQuad(96,0,32,64,256,64),
		up = 		love.graphics.newQuad(128,0,32,64,256,64),
		upleft = 	love.graphics.newQuad(160,0,32,64,256,64),
		left = 		love.graphics.newQuad(192,0,32,64,256,64),
		downleft = 	love.graphics.newQuad(224,0,32,64,256,64),
	}
-- The image of our guy
Guy.image = love.graphics.newImage("images/guy.png")
Guy.width = Guy.image:getWidth()
Guy.height = Guy.image:getHeight()


local g = anim8.newGrid(32, 64, Guy.image:getWidth(), Guy.image:getHeight())
animation = anim8.newAnimation('once', g('1-8,1'), 0.1)

local gx, gy -- player pos for the whole file. Remove later. I'm not even using this.
local canUse --Extra check variable

-- Move the guy around the tiles
function Guy.moveTile(x,y)

--Variables for position. Shit is pissing me off. Trying to round and what not.
	gx = Guy.tileX
	gy = Guy.tileY
	GuyTileX = math.ceil(Guy.tileX)
	GuyTileY = math.ceil(Guy.tileY)
	GuyTileXX = math.floor((Guy.tileX+x+0) + math.floor(Guy.moveTilePlusX))
	GuyTileYY = math.floor((Guy.tileY+y+0) + math.floor(Guy.moveTilePlusY))
	

	
	-- Change the facing direction
--[[ 	if x > 0 then Guy.facing = "right"
	elseif x < 0 then Guy.facing = "left"
	elseif y > 0 then Guy.facing = "down"
	else Guy.facing = "up" end ]]
	-- Grab the tile
	
	

	
	--Checks if next tile is valid or is an obstacle and/or Useable
	--This shit needs work with new way player moves. Shit is whack, yo.
	
	
	if (checkObstacle(map, GuyTileX, GuyTileY) and checkUseable(map, GuyTileX, GuyTileY)) then
			ConsoleInfo.obstacle = "true"
			ConsoleInfo.useable = "true"
			canUse = "true"
			return
	end
	
	if ( not checkObstacle(map, GuyTileX, GuyTileY) and checkUseable(map, GuyTileX, GuyTileY)) then
			ConsoleInfo.obstacle = "false"
			ConsoleInfo.useable = "true"
			canUse = "true"
	end

	if (checkObstacle(map, GuyTileX, GuyTileY) and not checkUseable(map, GuyTileX, GuyTileY)) then
			ConsoleInfo.obstacle = "true"
			ConsoleInfo.useable = "false"
			canUse = "false"
			return
	end
	
	if (not checkObstacle(map, GuyTileX, GuyTileY) and not checkUseable(map, GuyTileX, GuyTileY)) then
			ConsoleInfo.obstacle = "false"
			ConsoleInfo.useable = "false"
			canUse = "false"
	end	


	-- Otherwise change the guy's tile
	Guy.tileX = Guy.tileX + x
	Guy.tileY = Guy.tileY + y
	Guy:moveTo(Guy.tileX*map.tileWidth, (Guy.tileY+1)*map.tileHeight-Guy.height)

	
	
	--Data sent to console. Change this to position variables.  
	
local plyX, plyY, plyXX, plyYY = Guy.tileX, Guy.tileY, Guy.tileX+x, Guy.tileY+y
	
	ConsoleInfo.x = math.floor(plyX) --Exact X
	ConsoleInfo.y = math.floor(plyY) --Exact Y
	ConsoleInfo.xx = math.ceil(GuyTileXX) --Exact X + Direction X player is trying to move
	ConsoleInfo.yy = math.ceil(GuyTileYY) -- Exact Y + Direction Y player is trying to move
	ConsoleInfo.gx = gx --X with delta
	ConsoleInfo.gy = gy -- Y with delta

	
end

	
function checkObstacle(map, x, y)
    for name, layer in pairs(map.tileLayers) do
        if layer.tileData(x, y) and layer.tileData(x, y).properties.obstacle then

            return true, name
        end
    end
	
    return false
end

function checkUseable(map, x, y)

		if map.tileLayers.Furniture.tileData(x,y) == nil then
		

			return false, "nil" end
	
			if map.tileLayers.Furniture.tileData(x,y).properties.useable then
					 tilename = map.tileLayers.Furniture.tileData(x,y).properties.name
					
				return true, tilename
 
			end

    return false, "norm"
end



function useObject(map, x, y, useable)
local bool, nam

	if checkUseable(map, x, y) then
	
		 bool, nam = checkUseable(map, x, y)
		 
			ConsoleInfo.checkBool = bool
			ConsoleInfo.checkName = nam
			
		if (bool == true and nam == "radio") then
	
			ConsoleInfo.checkBool = "true"
			ConsoleInfo.checkName = nam
			playRadio()
	
		end
		
	end

end

function playRadio()
TEsound.stop("all", false)
--TEsound.tagVolume("all",.1)
TEsound.playLooping(music, "all", 1, 0.1)

end

-- Do this at first to make sure the guy is drawn correctly.
Guy.moveTile(0,0)
Guy.facing = "down"

-- Draw our guy. This function is passed to TileSet.drawAfterTile() which calls it passing the
-- x and y value of the bottom left corner of the tile.
function Guy.draw()
	love.graphics.drawq(Guy.image, Guy.quads[Guy.facing], Guy.x, Guy.y)
	
	
end


-- Our example class
local Inn = {}

-- Called from love.keypressed()
function Inn.keypressed(k)
	if k == 'w' then Guy.moveTilePlusY = -1 end
	if k == 'a' then Guy.moveTilePlusX = -1 end
 	if k == 's' then Guy.moveTilePlusY = 1 end
	if k == 'd' then Guy.moveTilePlusX = 1 end

	if k == 'e' then useObject(map, Guy.tileX+gx, Guy.tileY+gy, canUse) end
	if k == 'n' then GUI.ShowTable(map.tileLayers.Furniture.tileData(10,6).properties) end
	if k == 'm' then animation:draw(Guy.image, Guy.x, Guy.y) end

end

-- Resets the example
function Inn.reset()
	global.tx = 140
	global.ty = 40
	Guy.tileX = 10
	Guy.tileY = 7
	Guy.moveTile(0,0)
	Guy.facing = "down"
	displayTime = 0
end

-- Update the display time for the character control instructions
function Inn.update(dt)
	displayTime = displayTime + dt
	TEsound.cleanup()
	 animation:update(dt)
	 
	 
	 
	 if love.keyboard.isDown( "w" ) then 
		Guy.moveTile(0,-Guy.speed*dt) 
	end
	 if love.keyboard.isDown( "a" ) then Guy.moveTile(-Guy.speed*dt,0) end
	 if love.keyboard.isDown( "s" ) then Guy.moveTile(0,Guy.speed*dt) end
	 if love.keyboard.isDown( "d" ) then Guy.moveTile(Guy.speed*dt,0) end
	 
end

-- Called from love.draw()
function Inn.draw()

GUI.Console(ConsoleInfo)
	

	-- Set sprite batches if they are different than the settings.
	map.useSpriteBatch = global.useBatch

	-- Scale and translate the game screen for map drawing
	local ftx, fty = math.floor(global.tx), math.floor(global.ty)
	love.graphics.push()
	love.graphics.scale(global.scale)
	love.graphics.translate(ftx, fty)
	
	-- Limit the draw range 
	if global.limitDrawing then 
		map:autoDrawRange(ftx, fty, global.scale, -100) 
	else 
		map:autoDrawRange(ftx, fty, global.scale, 50) 
	end
	
	-- Queue our guy to be drawn after the tile he's on and then draw the map.
	local maxDraw = global.benchmark and 20 or 1
	for i=1,maxDraw do 
		map:draw() 
	end
	love.graphics.rectangle("line", map:getDrawRange())
	
	-- Reset the scale and translation.
	love.graphics.pop()

end

return Inn